package org.test.commons;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.VelocityException;
import org.jetbrains.annotations.NotNull;
import org.springframework.ui.velocity.VelocityEngineUtils;

import java.util.Map;

public final class VelocityUtil {

    private final Log log = LogFactory.getLog(this.getClass());

    private VelocityEngine velocityEngine;

    public void setVelocityEngine(VelocityEngine velocityEngine) {this.velocityEngine = velocityEngine;}

    public String mergeVelocityTemplate(@NotNull final String templateName, @NotNull final Map<String, Object> model, @NotNull final String encoding) {
        String result = null;
        try {
            result = VelocityEngineUtils.mergeTemplateIntoString(velocityEngine, '/' + templateName, encoding, model);
        } catch (VelocityException e) {
            log.error(e);
        }
        return result;
    }
}

