package org.test;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.testng.AbstractTestNGSpringContextTests;
import org.test.commons.VelocityUtil;
import org.testng.annotations.Test;

import java.util.HashMap;
import java.util.Map;

import static org.testng.Assert.assertTrue;

/**
 * @author <a href="mailto:jean.eastcode@gmail.com">Jean Seurin</a>
 * @version $Id$
 * @since 1.0 - Dec 17, 2009 - 11:49:54 AM
 */
@ContextConfiguration(locations = "classpath:mailConfig.xml")
public class VelocityTest extends AbstractTestNGSpringContextTests {

    @Autowired VelocityUtil velocityUtil;

    @Test
    public void testMergeVelocityTemplate() {
        Map<String, Object> model = new HashMap<String, Object>(3);
        final String id = "123456789";
        model.put("id", id);
        model.put("password", "passssss");
        String result = velocityUtil.mergeVelocityTemplate("test-template.vm", model, "UTF-8");
        //validates the current template is being used
        assertTrue(result.contains("You've been subscribed"));
        //validates the defaultMailTemplate is found
        assertTrue(result.contains("Disclaimer"));
        //validates variables merge occured 
        assertTrue(result.contains(id));
    }
}
